/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the WriteAction type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WriteAction{}

// WriteAction struct for WriteAction
type WriteAction struct {
	// Primary key of document. The value is null when document is not persisted.
	Id *string `json:"id,omitempty"`
	// Object ID
	ObjectId interface{} `json:"object_id,omitempty"`
	// Object type
	ObjectType *string `json:"object_type,omitempty"`
	// Action type
	Type *string `json:"type,omitempty"`
	// Customer ID
	CustomerId *string `json:"customer_id,omitempty"`
	Status     *string `json:"status,omitempty"`
	// Action status detail
	StatusDetail *string `json:"status_detail,omitempty"`
	// Last execution timestamp
	LastMarkInProgress NullableInt32 `json:"last_mark_in_progress,omitempty"`
	// Last execution timestamp
	LastExecution NullableInt32 `json:"last_execution,omitempty"`
	// Last success execution timestamp
	LastSuccessExecution NullableInt32 `json:"last_success_execution,omitempty"`
	// Duration
	Duration NullableString `json:"duration,omitempty"`
	// Error iteration count
	ErrorCount *int32 `json:"error_count,omitempty"`
	// Is the action currently being processed?
	IsBeingProcessed *bool `json:"is_being_processed,omitempty"`
	// Whether it is waiting for the first execution in action's lifetime
	InitialPending *bool `json:"initial_pending,omitempty"`
	// After how many seconds the action should be retried if it is failed. Default is 0 meaning run retry on next Dispatcher's tick.  Example: set to 60*60*2 to retry action not earlier than 2hrs after failure
	OnErrorRetryTimeout *int32 `json:"on_error_retry_timeout,omitempty"`
	// Relations to other actions. By defining this, we can for instance define that some extraction must be run before some write action etc.
	Constraints []interface{} `json:"constraints,omitempty"`
	// Action Schedule settings
	Schedule  interface{} `json:"schedule,omitempty"`
	RequestId interface{} `json:"request_id,omitempty"`
	// Result
	Result            map[string]interface{} `json:"result,omitempty"`
	WriteMode         *string                `json:"write_mode,omitempty"`
	Stream            *bool                  `json:"stream,omitempty"`
	UniqueColumns     []interface{}          `json:"unique_columns,omitempty"`
	SetupInstructions *string                `json:"setup_instructions,omitempty"`
}

// NewWriteAction instantiates a new WriteAction object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWriteAction() *WriteAction {
	this := WriteAction{}
	return &this
}

// NewWriteActionWithDefaults instantiates a new WriteAction object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWriteActionWithDefaults() *WriteAction {
	this := WriteAction{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *WriteAction) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *WriteAction) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *WriteAction) SetId(v string) {
	o.Id = &v
}

// GetObjectId returns the ObjectId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetObjectId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.ObjectId
}

// GetObjectIdOk returns a tuple with the ObjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetObjectIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ObjectId) {
		return nil, false
	}
	return &o.ObjectId, true
}

// HasObjectId returns a boolean if a field has been set.
func (o *WriteAction) HasObjectId() bool {
	if o != nil && IsNil(o.ObjectId) {
		return true
	}

	return false
}

// SetObjectId gets a reference to the given interface{} and assigns it to the ObjectId field.
func (o *WriteAction) SetObjectId(v interface{}) {
	o.ObjectId = v
}

// GetObjectType returns the ObjectType field value if set, zero value otherwise.
func (o *WriteAction) GetObjectType() string {
	if o == nil || IsNil(o.ObjectType) {
		var ret string
		return ret
	}
	return *o.ObjectType
}

// GetObjectTypeOk returns a tuple with the ObjectType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetObjectTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ObjectType) {
		return nil, false
	}
	return o.ObjectType, true
}

// HasObjectType returns a boolean if a field has been set.
func (o *WriteAction) HasObjectType() bool {
	if o != nil && !IsNil(o.ObjectType) {
		return true
	}

	return false
}

// SetObjectType gets a reference to the given string and assigns it to the ObjectType field.
func (o *WriteAction) SetObjectType(v string) {
	o.ObjectType = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *WriteAction) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *WriteAction) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *WriteAction) SetType(v string) {
	o.Type = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *WriteAction) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *WriteAction) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *WriteAction) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *WriteAction) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *WriteAction) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *WriteAction) SetStatus(v string) {
	o.Status = &v
}

// GetStatusDetail returns the StatusDetail field value if set, zero value otherwise.
func (o *WriteAction) GetStatusDetail() string {
	if o == nil || IsNil(o.StatusDetail) {
		var ret string
		return ret
	}
	return *o.StatusDetail
}

// GetStatusDetailOk returns a tuple with the StatusDetail field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetStatusDetailOk() (*string, bool) {
	if o == nil || IsNil(o.StatusDetail) {
		return nil, false
	}
	return o.StatusDetail, true
}

// HasStatusDetail returns a boolean if a field has been set.
func (o *WriteAction) HasStatusDetail() bool {
	if o != nil && !IsNil(o.StatusDetail) {
		return true
	}

	return false
}

// SetStatusDetail gets a reference to the given string and assigns it to the StatusDetail field.
func (o *WriteAction) SetStatusDetail(v string) {
	o.StatusDetail = &v
}

// GetLastMarkInProgress returns the LastMarkInProgress field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetLastMarkInProgress() int32 {
	if o == nil || IsNil(o.LastMarkInProgress.Get()) {
		var ret int32
		return ret
	}
	return *o.LastMarkInProgress.Get()
}

// GetLastMarkInProgressOk returns a tuple with the LastMarkInProgress field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetLastMarkInProgressOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastMarkInProgress.Get(), o.LastMarkInProgress.IsSet()
}

// HasLastMarkInProgress returns a boolean if a field has been set.
func (o *WriteAction) HasLastMarkInProgress() bool {
	if o != nil && o.LastMarkInProgress.IsSet() {
		return true
	}

	return false
}

// SetLastMarkInProgress gets a reference to the given NullableInt32 and assigns it to the LastMarkInProgress field.
func (o *WriteAction) SetLastMarkInProgress(v int32) {
	o.LastMarkInProgress.Set(&v)
}

// SetLastMarkInProgressNil sets the value for LastMarkInProgress to be an explicit nil
func (o *WriteAction) SetLastMarkInProgressNil() {
	o.LastMarkInProgress.Set(nil)
}

// UnsetLastMarkInProgress ensures that no value is present for LastMarkInProgress, not even an explicit nil
func (o *WriteAction) UnsetLastMarkInProgress() {
	o.LastMarkInProgress.Unset()
}

// GetLastExecution returns the LastExecution field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetLastExecution() int32 {
	if o == nil || IsNil(o.LastExecution.Get()) {
		var ret int32
		return ret
	}
	return *o.LastExecution.Get()
}

// GetLastExecutionOk returns a tuple with the LastExecution field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetLastExecutionOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastExecution.Get(), o.LastExecution.IsSet()
}

// HasLastExecution returns a boolean if a field has been set.
func (o *WriteAction) HasLastExecution() bool {
	if o != nil && o.LastExecution.IsSet() {
		return true
	}

	return false
}

// SetLastExecution gets a reference to the given NullableInt32 and assigns it to the LastExecution field.
func (o *WriteAction) SetLastExecution(v int32) {
	o.LastExecution.Set(&v)
}

// SetLastExecutionNil sets the value for LastExecution to be an explicit nil
func (o *WriteAction) SetLastExecutionNil() {
	o.LastExecution.Set(nil)
}

// UnsetLastExecution ensures that no value is present for LastExecution, not even an explicit nil
func (o *WriteAction) UnsetLastExecution() {
	o.LastExecution.Unset()
}

// GetLastSuccessExecution returns the LastSuccessExecution field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetLastSuccessExecution() int32 {
	if o == nil || IsNil(o.LastSuccessExecution.Get()) {
		var ret int32
		return ret
	}
	return *o.LastSuccessExecution.Get()
}

// GetLastSuccessExecutionOk returns a tuple with the LastSuccessExecution field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetLastSuccessExecutionOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.LastSuccessExecution.Get(), o.LastSuccessExecution.IsSet()
}

// HasLastSuccessExecution returns a boolean if a field has been set.
func (o *WriteAction) HasLastSuccessExecution() bool {
	if o != nil && o.LastSuccessExecution.IsSet() {
		return true
	}

	return false
}

// SetLastSuccessExecution gets a reference to the given NullableInt32 and assigns it to the LastSuccessExecution field.
func (o *WriteAction) SetLastSuccessExecution(v int32) {
	o.LastSuccessExecution.Set(&v)
}

// SetLastSuccessExecutionNil sets the value for LastSuccessExecution to be an explicit nil
func (o *WriteAction) SetLastSuccessExecutionNil() {
	o.LastSuccessExecution.Set(nil)
}

// UnsetLastSuccessExecution ensures that no value is present for LastSuccessExecution, not even an explicit nil
func (o *WriteAction) UnsetLastSuccessExecution() {
	o.LastSuccessExecution.Unset()
}

// GetDuration returns the Duration field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetDuration() string {
	if o == nil || IsNil(o.Duration.Get()) {
		var ret string
		return ret
	}
	return *o.Duration.Get()
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetDurationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Duration.Get(), o.Duration.IsSet()
}

// HasDuration returns a boolean if a field has been set.
func (o *WriteAction) HasDuration() bool {
	if o != nil && o.Duration.IsSet() {
		return true
	}

	return false
}

// SetDuration gets a reference to the given NullableString and assigns it to the Duration field.
func (o *WriteAction) SetDuration(v string) {
	o.Duration.Set(&v)
}

// SetDurationNil sets the value for Duration to be an explicit nil
func (o *WriteAction) SetDurationNil() {
	o.Duration.Set(nil)
}

// UnsetDuration ensures that no value is present for Duration, not even an explicit nil
func (o *WriteAction) UnsetDuration() {
	o.Duration.Unset()
}

// GetErrorCount returns the ErrorCount field value if set, zero value otherwise.
func (o *WriteAction) GetErrorCount() int32 {
	if o == nil || IsNil(o.ErrorCount) {
		var ret int32
		return ret
	}
	return *o.ErrorCount
}

// GetErrorCountOk returns a tuple with the ErrorCount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetErrorCountOk() (*int32, bool) {
	if o == nil || IsNil(o.ErrorCount) {
		return nil, false
	}
	return o.ErrorCount, true
}

// HasErrorCount returns a boolean if a field has been set.
func (o *WriteAction) HasErrorCount() bool {
	if o != nil && !IsNil(o.ErrorCount) {
		return true
	}

	return false
}

// SetErrorCount gets a reference to the given int32 and assigns it to the ErrorCount field.
func (o *WriteAction) SetErrorCount(v int32) {
	o.ErrorCount = &v
}

// GetIsBeingProcessed returns the IsBeingProcessed field value if set, zero value otherwise.
func (o *WriteAction) GetIsBeingProcessed() bool {
	if o == nil || IsNil(o.IsBeingProcessed) {
		var ret bool
		return ret
	}
	return *o.IsBeingProcessed
}

// GetIsBeingProcessedOk returns a tuple with the IsBeingProcessed field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetIsBeingProcessedOk() (*bool, bool) {
	if o == nil || IsNil(o.IsBeingProcessed) {
		return nil, false
	}
	return o.IsBeingProcessed, true
}

// HasIsBeingProcessed returns a boolean if a field has been set.
func (o *WriteAction) HasIsBeingProcessed() bool {
	if o != nil && !IsNil(o.IsBeingProcessed) {
		return true
	}

	return false
}

// SetIsBeingProcessed gets a reference to the given bool and assigns it to the IsBeingProcessed field.
func (o *WriteAction) SetIsBeingProcessed(v bool) {
	o.IsBeingProcessed = &v
}

// GetInitialPending returns the InitialPending field value if set, zero value otherwise.
func (o *WriteAction) GetInitialPending() bool {
	if o == nil || IsNil(o.InitialPending) {
		var ret bool
		return ret
	}
	return *o.InitialPending
}

// GetInitialPendingOk returns a tuple with the InitialPending field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetInitialPendingOk() (*bool, bool) {
	if o == nil || IsNil(o.InitialPending) {
		return nil, false
	}
	return o.InitialPending, true
}

// HasInitialPending returns a boolean if a field has been set.
func (o *WriteAction) HasInitialPending() bool {
	if o != nil && !IsNil(o.InitialPending) {
		return true
	}

	return false
}

// SetInitialPending gets a reference to the given bool and assigns it to the InitialPending field.
func (o *WriteAction) SetInitialPending(v bool) {
	o.InitialPending = &v
}

// GetOnErrorRetryTimeout returns the OnErrorRetryTimeout field value if set, zero value otherwise.
func (o *WriteAction) GetOnErrorRetryTimeout() int32 {
	if o == nil || IsNil(o.OnErrorRetryTimeout) {
		var ret int32
		return ret
	}
	return *o.OnErrorRetryTimeout
}

// GetOnErrorRetryTimeoutOk returns a tuple with the OnErrorRetryTimeout field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetOnErrorRetryTimeoutOk() (*int32, bool) {
	if o == nil || IsNil(o.OnErrorRetryTimeout) {
		return nil, false
	}
	return o.OnErrorRetryTimeout, true
}

// HasOnErrorRetryTimeout returns a boolean if a field has been set.
func (o *WriteAction) HasOnErrorRetryTimeout() bool {
	if o != nil && !IsNil(o.OnErrorRetryTimeout) {
		return true
	}

	return false
}

// SetOnErrorRetryTimeout gets a reference to the given int32 and assigns it to the OnErrorRetryTimeout field.
func (o *WriteAction) SetOnErrorRetryTimeout(v int32) {
	o.OnErrorRetryTimeout = &v
}

// GetConstraints returns the Constraints field value if set, zero value otherwise.
func (o *WriteAction) GetConstraints() []interface{} {
	if o == nil || IsNil(o.Constraints) {
		var ret []interface{}
		return ret
	}
	return o.Constraints
}

// GetConstraintsOk returns a tuple with the Constraints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetConstraintsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Constraints) {
		return nil, false
	}
	return o.Constraints, true
}

// HasConstraints returns a boolean if a field has been set.
func (o *WriteAction) HasConstraints() bool {
	if o != nil && !IsNil(o.Constraints) {
		return true
	}

	return false
}

// SetConstraints gets a reference to the given []interface{} and assigns it to the Constraints field.
func (o *WriteAction) SetConstraints(v []interface{}) {
	o.Constraints = v
}

// GetSchedule returns the Schedule field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetSchedule() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Schedule
}

// GetScheduleOk returns a tuple with the Schedule field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetScheduleOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Schedule) {
		return nil, false
	}
	return &o.Schedule, true
}

// HasSchedule returns a boolean if a field has been set.
func (o *WriteAction) HasSchedule() bool {
	if o != nil && IsNil(o.Schedule) {
		return true
	}

	return false
}

// SetSchedule gets a reference to the given interface{} and assigns it to the Schedule field.
func (o *WriteAction) SetSchedule(v interface{}) {
	o.Schedule = v
}

// GetRequestId returns the RequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *WriteAction) GetRequestId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.RequestId
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *WriteAction) GetRequestIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.RequestId) {
		return nil, false
	}
	return &o.RequestId, true
}

// HasRequestId returns a boolean if a field has been set.
func (o *WriteAction) HasRequestId() bool {
	if o != nil && IsNil(o.RequestId) {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given interface{} and assigns it to the RequestId field.
func (o *WriteAction) SetRequestId(v interface{}) {
	o.RequestId = v
}

// GetResult returns the Result field value if set, zero value otherwise.
func (o *WriteAction) GetResult() map[string]interface{} {
	if o == nil || IsNil(o.Result) {
		var ret map[string]interface{}
		return ret
	}
	return o.Result
}

// GetResultOk returns a tuple with the Result field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetResultOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Result) {
		return map[string]interface{}{}, false
	}
	return o.Result, true
}

// HasResult returns a boolean if a field has been set.
func (o *WriteAction) HasResult() bool {
	if o != nil && !IsNil(o.Result) {
		return true
	}

	return false
}

// SetResult gets a reference to the given map[string]interface{} and assigns it to the Result field.
func (o *WriteAction) SetResult(v map[string]interface{}) {
	o.Result = v
}

// GetWriteMode returns the WriteMode field value if set, zero value otherwise.
func (o *WriteAction) GetWriteMode() string {
	if o == nil || IsNil(o.WriteMode) {
		var ret string
		return ret
	}
	return *o.WriteMode
}

// GetWriteModeOk returns a tuple with the WriteMode field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetWriteModeOk() (*string, bool) {
	if o == nil || IsNil(o.WriteMode) {
		return nil, false
	}
	return o.WriteMode, true
}

// HasWriteMode returns a boolean if a field has been set.
func (o *WriteAction) HasWriteMode() bool {
	if o != nil && !IsNil(o.WriteMode) {
		return true
	}

	return false
}

// SetWriteMode gets a reference to the given string and assigns it to the WriteMode field.
func (o *WriteAction) SetWriteMode(v string) {
	o.WriteMode = &v
}

// GetStream returns the Stream field value if set, zero value otherwise.
func (o *WriteAction) GetStream() bool {
	if o == nil || IsNil(o.Stream) {
		var ret bool
		return ret
	}
	return *o.Stream
}

// GetStreamOk returns a tuple with the Stream field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetStreamOk() (*bool, bool) {
	if o == nil || IsNil(o.Stream) {
		return nil, false
	}
	return o.Stream, true
}

// HasStream returns a boolean if a field has been set.
func (o *WriteAction) HasStream() bool {
	if o != nil && !IsNil(o.Stream) {
		return true
	}

	return false
}

// SetStream gets a reference to the given bool and assigns it to the Stream field.
func (o *WriteAction) SetStream(v bool) {
	o.Stream = &v
}

// GetUniqueColumns returns the UniqueColumns field value if set, zero value otherwise.
func (o *WriteAction) GetUniqueColumns() []interface{} {
	if o == nil || IsNil(o.UniqueColumns) {
		var ret []interface{}
		return ret
	}
	return o.UniqueColumns
}

// GetUniqueColumnsOk returns a tuple with the UniqueColumns field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetUniqueColumnsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.UniqueColumns) {
		return nil, false
	}
	return o.UniqueColumns, true
}

// HasUniqueColumns returns a boolean if a field has been set.
func (o *WriteAction) HasUniqueColumns() bool {
	if o != nil && !IsNil(o.UniqueColumns) {
		return true
	}

	return false
}

// SetUniqueColumns gets a reference to the given []interface{} and assigns it to the UniqueColumns field.
func (o *WriteAction) SetUniqueColumns(v []interface{}) {
	o.UniqueColumns = v
}

// GetSetupInstructions returns the SetupInstructions field value if set, zero value otherwise.
func (o *WriteAction) GetSetupInstructions() string {
	if o == nil || IsNil(o.SetupInstructions) {
		var ret string
		return ret
	}
	return *o.SetupInstructions
}

// GetSetupInstructionsOk returns a tuple with the SetupInstructions field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WriteAction) GetSetupInstructionsOk() (*string, bool) {
	if o == nil || IsNil(o.SetupInstructions) {
		return nil, false
	}
	return o.SetupInstructions, true
}

// HasSetupInstructions returns a boolean if a field has been set.
func (o *WriteAction) HasSetupInstructions() bool {
	if o != nil && !IsNil(o.SetupInstructions) {
		return true
	}

	return false
}

// SetSetupInstructions gets a reference to the given string and assigns it to the SetupInstructions field.
func (o *WriteAction) SetSetupInstructions(v string) {
	o.SetupInstructions = &v
}

func (o WriteAction) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WriteAction) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if o.ObjectId != nil {
		toSerialize["object_id"] = o.ObjectId
	}
	if !IsNil(o.ObjectType) {
		toSerialize["object_type"] = o.ObjectType
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customer_id"] = o.CustomerId
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.StatusDetail) {
		toSerialize["status_detail"] = o.StatusDetail
	}
	if o.LastMarkInProgress.IsSet() {
		toSerialize["last_mark_in_progress"] = o.LastMarkInProgress.Get()
	}
	if o.LastExecution.IsSet() {
		toSerialize["last_execution"] = o.LastExecution.Get()
	}
	if o.LastSuccessExecution.IsSet() {
		toSerialize["last_success_execution"] = o.LastSuccessExecution.Get()
	}
	if o.Duration.IsSet() {
		toSerialize["duration"] = o.Duration.Get()
	}
	if !IsNil(o.ErrorCount) {
		toSerialize["error_count"] = o.ErrorCount
	}
	if !IsNil(o.IsBeingProcessed) {
		toSerialize["is_being_processed"] = o.IsBeingProcessed
	}
	if !IsNil(o.InitialPending) {
		toSerialize["initial_pending"] = o.InitialPending
	}
	if !IsNil(o.OnErrorRetryTimeout) {
		toSerialize["on_error_retry_timeout"] = o.OnErrorRetryTimeout
	}
	if !IsNil(o.Constraints) {
		toSerialize["constraints"] = o.Constraints
	}
	if o.Schedule != nil {
		toSerialize["schedule"] = o.Schedule
	}
	if o.RequestId != nil {
		toSerialize["request_id"] = o.RequestId
	}
	if !IsNil(o.Result) {
		toSerialize["result"] = o.Result
	}
	if !IsNil(o.WriteMode) {
		toSerialize["write_mode"] = o.WriteMode
	}
	if !IsNil(o.Stream) {
		toSerialize["stream"] = o.Stream
	}
	if !IsNil(o.UniqueColumns) {
		toSerialize["unique_columns"] = o.UniqueColumns
	}
	if !IsNil(o.SetupInstructions) {
		toSerialize["setup_instructions"] = o.SetupInstructions
	}
	return toSerialize, nil
}

type NullableWriteAction struct {
	value *WriteAction
	isSet bool
}

func (v NullableWriteAction) Get() *WriteAction {
	return v.value
}

func (v *NullableWriteAction) Set(val *WriteAction) {
	v.value = val
	v.isSet = true
}

func (v NullableWriteAction) IsSet() bool {
	return v.isSet
}

func (v *NullableWriteAction) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWriteAction(val *WriteAction) *NullableWriteAction {
	return &NullableWriteAction{value: val, isSet: true}
}

func (v NullableWriteAction) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWriteAction) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
